//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property strict      "New MQL4 Compiler"
#property copyright   "2012-2020, MonteCarlo, hiehie1062@foxmail.com"
#property link        "https://www.mql5.com/zh/users/mc828838"
#property description "&_MC_SML"
#property version     "7.9"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window
//---
extern string XSML="X";
extern int    Number=0;
extern bool   Send=FALSE;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int S[7]={003,006,009,012,015,018,021};
int M[7]={030,035,040,045,050,055,060};
int L[7]={075,083,091,099,107,115,123};
//---
int SortedLevel[6];
int SortedNames[6];
//---
double SW[7][2];
string UniqueID="",GlobalID="";
string Nation[6]={"EUR","GBP","USD","CAD","AUD","JPY"};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void init() {
   GlobalID=XSML+DoubleToString(Number,0)+"_";
   UniqueID="X"+DoubleToString(Number,0)+"_";
   //---
   for(int i=0; i<6; i++) {
      if(!GlobalVariableCheck("X_"+GlobalID+GetText(i))) GlobalVariableSet("X_"+GlobalID+GetText(i),999);
   }
   if(!GlobalVariableCheck(".MC_KEY")) GlobalVariableSet(".MC_KEY",FALSE);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void iMain() {
   int UP=0,DN=0;
   for(int i=0; i<7; i++) {
      for(int j=0; j<2; j++) SW[i][j]=iMA(NULL,0,GetPeriod(XSML,i),0,MODE_EMA,PRICE_TYPICAL,j);
      //---
      if(SW[i][0]>SW[i][1]) UP+=1;
      if(SW[i][0]<SW[i][1]) DN-=1;
   }
   int X=UP+DN;
   if(X>0) ImmobileText(0,220,GetYAxis(Number),clrNavy,DoubleToStr(MathAbs(X),0),"LEVEL");
   if(X<0) ImmobileText(0,220,GetYAxis(Number),clrGold,DoubleToStr(MathAbs(X),0),"LEVEL");
   //---
   GlobalVariableSet(GlobalID+StringSubstr(Symbol(),0,6),X);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetPeriod(string x,int n) {
   if(x=="S") return(S[n]);
   if(x=="M") return(M[n]);
   if(x=="L") return(L[n]);
   return(1);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void start() {
   static datetime UpdateTime=0;
   if(UpdateTime!=TimeCurrent()) {
      UpdateTime=TimeCurrent();
      //---
      if(XSML=="S" || XSML=="M" || XSML=="L") iMain();
      else return;
      //---
      if(!IsTesting()) {
         if(GlobalVariableGet(".MC_KEY")==AccountNumber()-1062+828838) {
            if(!IsExpertEnabled()) Alert("Expert No Enabled");
            ObjectDelete(UniqueID+"KEY");
            UpdateArray();
            SortedArray();
            ShowSWChart();
         } else {
            DeleteObject(StringLen(UniqueID),UniqueID);
            ImmobileText(0,90,15,clrWhite,".MC_KEY Error","KEY");
         }
      }
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateArray() {
   ArrayInitialize(SortedLevel,0.0);
   ArrayInitialize(SortedNames,0.0);
   //---
   int Total=GlobalVariablesTotal()-1;
   for(int i=Total; i>=0; i--) {
      //---
      string Name=GlobalVariableName(i);
      if(StringSubstr(Name,0,3)==GlobalID) {
         //---
         double Value=GlobalVariableGet(Name);
         for(int j=0; j<6; j++) {
            if(StringSubstr(Name,3,3)==Nation[j]) {
               if(Value>0) SortedLevel[j]++;
               if(Value<0) SortedLevel[j]--;
               SortedNames[j]=j;
            }
            if(StringSubstr(Name,6,3)==Nation[j]) {
               if(Value<0) SortedLevel[j]++;
               if(Value>0) SortedLevel[j]--;
               SortedNames[j]=j;
            }
         }
      }
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SortedArray() {
   int TempLevel=0;
   int TempNames=0;
   //---
   for(int i=0; i<6; i++) {
      for(int j=5; j>i; j--) {
         if(SortedLevel[j]<SortedLevel[j-1]) {
            //---
            TempLevel=SortedLevel[j-1];
            SortedLevel[j-1]=SortedLevel[j];
            SortedLevel[j]=TempLevel;
            //---
            TempNames=SortedNames[j-1];
            SortedNames[j-1]=SortedNames[j];
            SortedNames[j]=TempNames;
         }
      }
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ShowSWChart() {
   for(int i=0; i<6; i++) {
      ImmobileText(0,15*GetXAxis(i)+75,GetYAxis(Number),GetTextColor(SortedNames[i],i),GetText(SortedNames[i]),DoubleToStr(i,0));
      //---
      double Old=GlobalVariableGet("X_"+GlobalID+GetText(SortedNames[i]));
      //---
      if(i!=Old) {
         if(Send) {
            if(i>Old && i==5) {
               PlaySound("montecarlo.wav");
               Print(GlobalID+GetText(SortedNames[i])+": UP");
               //SendMail(GlobalID+GetText(SortedNames[i])+": UP",TimeToStr(TimeLocal(),TIME_SECONDS));
            }
            if(i<Old && i==0) {
               PlaySound("montecarlo.wav");
               Print(GlobalID+GetText(SortedNames[i])+": DN");
               //SendMail(GlobalID+GetText(SortedNames[i])+": DN",TimeToStr(TimeLocal(),TIME_SECONDS));
            }
         }
         GlobalVariableSet("X_"+GlobalID+GetText(SortedNames[i]),i);
      }
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetXAxis(int n) {
   int Rum=0;
   switch(n) {
      case 0: Rum=1; break;
      case 1: Rum=2; break;
      case 2: Rum=4; break;
      case 3: Rum=5; break;
      case 4: Rum=7; break;
      case 5: Rum=8; break;
      default:Rum=0;
   }
   return(Rum);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetYAxis(int n) {
   if(n==7) return(015);
   if(n==6) return(030);
   if(n==5) return(045);
   //---
   if(n==4) return(075);
   if(n==3) return(090);
   if(n==2) return(105);
   if(n==1) return(120);
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetText(int n) {
   if(Nation[n]=="EUR") return("E");
   if(Nation[n]=="GBP") return("G");
   if(Nation[n]=="USD") return("U");
   if(Nation[n]=="CAD") return("C");
   if(Nation[n]=="AUD") return("A");
   if(Nation[n]=="JPY") return("J");
   return("&");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
color GetTextColor(int n,int x) {
   if(Nation[n]==StringSubstr(Symbol(),0,3) || Nation[n]==StringSubstr(Symbol(),3,3)) {
      if(x>=4) return(clrNavy);
      if(x==3) return(clrDarkSlateBlue);
      if(x==2) return(clrGoldenrod);
      if(x<=1) return(clrGold);
   }
   return(clrDarkGray);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ImmobileText(int oCorner,int oX,int oY,color oColor,string oText,string oName) {
   string ObjectsName=UniqueID+oName;
   if(ObjectFind(ObjectsName)<0) {
      ObjectCreate(ObjectsName,OBJ_LABEL,0,0,0);
      ObjectSetText(ObjectsName,oText,8,"Arial Black",oColor);
      ObjectSet(ObjectsName,OBJPROP_CORNER,oCorner);
      ObjectSet(ObjectsName,OBJPROP_XDISTANCE,oX);
      ObjectSet(ObjectsName,OBJPROP_YDISTANCE,oY);
      ObjectSet(ObjectsName,OBJPROP_BACK,FALSE);
   } else {
      ObjectSetText(ObjectsName,oText,8,"Arial Black",oColor);
      ObjectSet(ObjectsName,OBJPROP_XDISTANCE,oX);
      ObjectSet(ObjectsName,OBJPROP_YDISTANCE,oY);
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() {
   DeleteObject(StringLen(UniqueID),UniqueID);
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteObject(int n,string name) {
	int Total=ObjectsTotal()-1;
   for(int i=Total; i>=0; i--) {
      if(StringSubstr(ObjectName(i),0,n)==name) ObjectDelete(ObjectName(i));
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
